/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTException_inl__
#define __RTException_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTException_h__
#include <RTException.h>
#endif

RTS_INLINE
Exception::Base::Base( void )
    : RTProtocol()
{
}

RTS_INLINE
Exception::Base::~Base( void )
{
}

RTS_INLINE
RTExceptionSignal
Exception::Base::arithmeticError( void )
{
    return RTExceptionSignal( this, rti_arithmeticError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::arithmeticError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_arithmeticError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::error( void )
{
    return RTExceptionSignal( this, rti_error );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::error( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_error, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::notFoundError( void )
{
    return RTExceptionSignal( this, rti_notFoundError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::notFoundError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_notFoundError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::notUnderstoodError( void )
{
    return RTExceptionSignal( this, rti_notUnderstoodError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::notUnderstoodError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_notUnderstoodError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::serviceAccessError( void )
{
    return RTExceptionSignal( this, rti_serviceAccessError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::serviceAccessError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_serviceAccessError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::streamError( void )
{
    return RTExceptionSignal( this, rti_streamError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::streamError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_streamError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::subclassResponsibilityError( void )
{
    return RTExceptionSignal( this, rti_subclassResponsibilityError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::subclassResponsibilityError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_subclassResponsibilityError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::timeSliceError( void )
{
    return RTExceptionSignal( this, rti_timeSliceError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::timeSliceError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_timeSliceError, value );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::userError( void )
{
    return RTExceptionSignal( this, rti_userError );
}

RTS_INLINE
RTExceptionSignal
Exception::Base::userError( const RTTypedValue & value )
{
    return RTExceptionSignal( this, rti_userError, value );
}

#endif // __RTException_inl__
