/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTExceptionSignal_h__
#define __RTExceptionSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

struct RTObject_class;
class  RTProtocol;
struct RTTypedValue;

// It is common to make temporaries of this struct.
//lint -esym(1901,RTExceptionSignal)

struct RTExceptionSignal
{
    // general application use
    RTS_INLINE int raise( void );

    // for use by run-time services library only
    RTS_INLINE RTExceptionSignal( RTProtocol         * port,
				  int                  signal );
    RTS_INLINE RTExceptionSignal( RTProtocol         * port,
				  int                  signal,
				  const RTTypedValue & data );
    RTS_INLINE ~RTExceptionSignal( void );

    RTProtocol           * _port;
    int                    _signal;
    const void           * _data;
    const RTObject_class * _type;
}; //lint !e1712

#if RTS_INLINES
#include <RTExceptionSignal.inl>
#endif

#endif // __RTExceptionSignal_h__
