/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTInSignal_h__
#define __RTInSignal_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTProtocol;

// It is common to make temporaries of this struct.
//lint -esym(1901,RTInSignal)

struct RTInSignal
{
    // general application use
    RTS_INLINE int purge      ( void );
    RTS_INLINE int purgeAt    ( int index );
    RTS_INLINE int recall     (            int front = 0 );
    RTS_INLINE int recallAt   ( int index, int front = 0 );
    RTS_INLINE int recallAll  (            int front = 0 );
    RTS_INLINE int recallAllAt( int index, int front = 0 );

    // for use by run-time services library only
    RTS_INLINE RTInSignal( RTProtocol *, int );
    RTS_INLINE ~RTInSignal( void );

    RTProtocol * _port;
    int          _signal;
}; //lint !e1712

#if RTS_INLINES
#include <RTInSignal.inl>
#endif

#endif // __RTInSignal_h__
