/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTStructures_h__
#define __RTStructures_h__ included

#include <RTConfig.h>
#include <RTVersion.h>

// Utilities

#include <RTAssociation.h>
#include <RTDictionary.h>
#include <RTFormat.h>
#include <RTMemoryUtil.h>
#include <RTnew.h>

// Data: descriptors

#include <RTFieldOffset.h>
#include <RTFieldDescriptor.h>
#include <RTVersionId.h>
#include <RTObject_class.h>
#include <RTTypeModifier.h>
#include <RTTypedValue.h>

// Data types

#include <RTDataObject.h>
#include <RTInteger.h>
#include <RTBoolean.h>
#include <RTByteBlock.h>
#include <RTCharacter.h>
#include <RTEnumerated.h>
#include <RTInterval.h>
#include <RTPointer.h>
#include <RTPriority.h>
#include <RTReal.h>
#include <RTSequence.h>
#include <RTSequenceOf.h>
#include <RTSignal.h>
#include <RTString.h>
#include <RTTime.h>
#include <RTTimespec.h>
#include <RTWrapper.h>

// Actors: descriptors

#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTBindingDescriptor.h>
#include <RTComponentDescriptor.h>
#include <RTInterfaceDescriptor.h>
#include <RTLocalBindingDescriptor.h>
#include <RTPortDescriptor.h>
#include <RTProtocolDescriptor.h>
#include <RTRelayDescriptor.h>
#include <RTSignalDescriptor.h>
#include <RTSystemDescriptor.h>

// Actors and controllers

#include <RTActorId.h>
#include <RTActorRef.h>
#include <RTMessage.h>
#include <RTMessageQ.h>
#include <RTResourceMgr.h>
#include <RTJob.h>
#include <RTCounts.h>
#include <RTController.h>
#include <RTActor.h>

#if USE_THREADS
#include <RTPeerController.h>
#include <RTCustomController.h>
#include <RTThread.h>
#else
#include <RTSoleController.h>
#endif

// Ports

#include <RTExceptionSignal.h>
#include <RTInSignal.h>
#include <RTOutSignal.h>
#include <RTSymmetricSignal.h>
#include <RTBindingEnd.h>
#include <RTProtocol.h>
#include <RTGlobalSignal.h>
#include <RTCachedString.h>
#include <RTRootProtocol.h>
#include <RTException.h>
#include <RTExternal.h>
#include <RTFrame.h>
#include <RTLog.h>
#include <RTTiming.h>
#include <RTTimerId.h>

// Encoding/decoding

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTAsciiDecoding.h>
#include <RTAsciiEncoding.h>
#include <RTVAsciiDecoding.h>
#include <RTVAsciiEncoding.h>

#include <RTIBuffer.h>
#include <RTOBuffer.h>
#include <RTMemoryInBuffer.h>
#include <RTMemoryOutBuffer.h>
#include <RTStreamBuffer.h>

// Connection services

#include <RTLayerConnector.h>
#include <RTActiveConnector.h>
#include <RTConnector.h>

#include <RTTcpSocket.h>

// Framework

#include <RTMain.h>

#include <RTCompatibility.h>

#endif // __RTStructures_h__
