/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTMessage.h>
#include <RTSpecialSignals.h>

#if 0 // these are not declared in the header file

void RTActor::suspend( RTController * initiator )
{
    if( initiator == context() )
	suspend();
    else if( ! isSuspended() )
	initiator->send( this, RTSuspendSignal, (void *)0, System, 0 );
}

void RTActor::resume( RTController * initiator )
{
    if( initiator == context() )
	resume();
    else if( isSuspended() )
	initiator->send( this, RTResumeSignal, (void *)0, System, 0 );
}

#endif

// These functions can be safely called only from the same context as that
// of the target behavior. When there is some possibility the target might
// be different, use the variants above.

static RTMessage suspendedMarkerMessage;

void RTActor::suspend( void )
{
    if( ! isSuspended() )
	suspendMsgs = &suspendedMarkerMessage;
}

void RTActor::resume( void )
{
    if( isSuspended() )
    {
	RTMessage * m;

	while( (m = suspendMsgs) != &suspendedMarkerMessage )
	{
	    suspendMsgs = (RTMessage *)m->next;
	    context()->requeueMsg( m, 1 /*front*/ );
	}
	suspendMsgs = (RTMessage *)0;
    }
}
