/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActor.h>
#include <RTActorProbe.h>
#include <RTActor_class.h>
#include <RTAsciiDecoding.h>
#include <RTAsciiEncoding.h>
#include <RTDebugger.h>
#include <RTFieldDescriptor.h>
#include <RTMemoryInBuffer.h>
#include <RTMemoryUtil.h>
#include <RTObject_class.h>
#include <RTTruncatingBuffer.h>

void RTActorProbe::accessFieldValue( void )
{
    FieldEntry * elem = _fieldList;

    if( elem == (FieldEntry *)0 )
	return;

    _fieldList = elem->next;
    elem->next = (FieldEntry *)0;

    const RTActor_class     * info      = _actor->getActorData();
    const RTFieldDescriptor * attribute = info->findAttribute( elem->varName );

    if( attribute != (const RTFieldDescriptor *)0 )
    {
	const int            bufferSize = 9000;
	char               * buffer     = new char [ (unsigned)bufferSize ];
	RTTruncatingBuffer   target ( buffer, bufferSize );
	RTAsciiEncoding      encoder( &target );

	if( elem->varValue != (const char *)0 )
	{
	    RTMemoryInBuffer source ( elem->varValue,
				      RTMemoryUtil::strlen( elem->varValue ) );
	    RTAsciiDecoding  decoder( &source );

	    (void)attribute->decode( _actor, &decoder ); // write
	}

	// read
	(void)attribute->encode( _actor, &encoder );
	(void)target.write( "", 1 );

	(void)_debugger->evtVariable( _id, _actorIndex, _actor,
				      elem->varName, buffer );

	delete [] buffer;
    }

    delete elem;
}
