/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTBoolean.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTInteger * _access( RTBoolean * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTBoolean;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTBoolean( *(const RTBoolean *)source );
}

#if OBJECT_DECODE || OBJECT_ENCODE
static const RTFieldDescriptor _values[] =
{
    {
	"False",
	(RTFieldOffset)0,
	(const RTObject_class *)0,
	(const RTTypeModifier *)0
    },
    {
	"True",
	(RTFieldOffset)1,
	(const RTObject_class *)0,
	(const RTTypeModifier *)0
    }
};
#endif // OBJECT_DECODE || OBJECT_ENCODE

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    return coding->get_enum( ((RTBoolean *)target)->value, 2, _values );
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    return coding->put_enum( ((const RTBoolean *)source)->value, 2, _values );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTBoolean",
	(RTFieldOffset)0,
	&RTBoolean::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTBoolean::classData =
{
    &RTType_RTInteger,
    (RTSuperAccessFunction)_access,
    "RTBoolean",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTBoolean ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTBoolean_installer( RTType_RTBoolean );
#endif

const RTObject_class * RTBoolean::getClassData( void ) const
{
    return &RTBoolean::classData;
}
