/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTByteBlock.h>
#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTFieldDescriptor.h>
#include <RTObject_class.h>
#include <RTnew.h>

static RTDataObject * _access( RTByteBlock * target )
{
    return target;
}

static void _init( const RTObject_class *, void * target )
{
    (void)new( target ) RTByteBlock;
}

static void _copy( const RTObject_class *,
		   void                 * target,
		   const void           * source )
{
    (void)new( target ) RTByteBlock( *(const RTByteBlock *)source );
}

#if OBJECT_DECODE
static int _decode( const RTObject_class *,
		    void                 * target,
		    RTDecoding           * coding )
{
    int    length;
    char * Contents;

    if( coding->get_opaque( length, Contents ) == 0 )
	return 0;
    else
    {
	RTByteBlock * data = (RTByteBlock *)target;

	delete [] data->Contents;

	data->length   = length;
	data->Contents = Contents;

	return 1;
    }
}
#endif

#if OBJECT_ENCODE
static int _encode( const RTObject_class *,
		    const void           * source,
		    RTEncoding           * coding )
{
    const RTByteBlock * data = (const RTByteBlock *)source;

    return coding->put_opaque( data->length, data->Contents );
}
#endif

static const RTFieldDescriptor _fields[] =
{
    {
	"RTByteBlock",
	(RTFieldOffset)0,
	&RTByteBlock::classData,
	(const RTTypeModifier *)0
    }
};

const RTObject_class RTByteBlock::classData =
{
    &RTType_RTDataObject,
    (RTSuperAccessFunction)_access,
    "RTByteBlock",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( RTByteBlock ),
    _init,
    _copy,
#if OBJECT_DECODE
    _decode,
#endif
#if OBJECT_ENCODE
    _encode,
#endif
    RTDataObject_destroy,
    1, _fields
};

#if OBJECT_DECODE
RTTypeInstaller RTByteBlock_installer( RTType_RTByteBlock );
#endif

const RTObject_class * RTByteBlock::getClassData( void ) const
{
    return &RTByteBlock::classData;
}
