/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTDebugger.h>
#if USE_THREADS
#include <RTMutex.h>
#endif
#include <RTProbe.h>

int RTDebugger::breakPoint( RTController * task, RTEventInfo * eventInfo )
{
#if USE_THREADS
    _mutex->enter();
#endif

    int shouldHalt = addEvent( eventInfo );

    if( phase() == RTJob::finished )
    {
	// do not wait
    }
    else if( shouldHalt > 0 )
    {
	task->_state = RTController::waitContinue;
	mode = Halted;
	evtRtsStatus();
    }

#if USE_THREADS
    _mutex->leave();
#endif

    return shouldHalt;
}
