/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifdef PRAGMA
#pragma implementation "RTDebugger.h"
#pragma implementation "RTDebugger.inl"
#endif

#include <RTDebugger.h>
#include <RTDiag.h>
#include <RTEventInfo.h>
#include <RTIOMonitor.h>
#include <RTProbe.h>

RTDebugger::~RTDebugger( void )
{
    RTAssert( tasks == (RTController *)0 );

#if OBSERVABLE
    for( int i = probes.size(); i-- != 0; )
    {
	RTProbe * probe = (RTProbe *)probes[ i ];

	if( probe != (RTProbe *)0 )
	{
	    delete probe;
	    probes[ i ] = (void *)0;
	}
    }
#endif

    RTController::resourceMgr.msgFree( freeList );

#if OBSERVABLE
    closeObservability();

    while( eventHead != (RTEventInfo *)0 )
    {
	RTEventInfo * temp = eventHead->next;

	delete eventHead;

	eventHead = temp;
    }
#endif

#ifdef _lint
    tasks     = (RTController *)0;
    freeList  = (RTMessage    *)0;
#if OBSERVABLE
    ioMonitor = (RTIOMonitor  *)0;
    eventHead = (RTEventInfo  *)0;
    eventTail = (RTEventInfo  *)0;
#endif // OBSERVABLE
#endif // _lint
}
