/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTEventInfo.h>

RTEventInfo::RTEventInfo( EventType theEventKind,
			  int       theProbeNr,
			  int       theActorIndex )
    : eventKind     (             theEventKind )
    , probeNr       (               theProbeNr )
    , actorIndex    (            theActorIndex )
    , observerId    (                       -1 )
    , daemonId      (                       -1 )
    , timestamp     (                   0L, 0L )
    , chainStrOrigin( (char                *)0 )
    , chainStrTrans ( (const char          *)0 )
    , chainOrigin   (                       -1 )
    , chainPosition (                       -1 )
    , chainParent   (                       -1 )
    , stateStrTarget( (char                *)0 )
    , stateTarget   (                       -1 )
    , portName      ( (char                *)0 )
    , message       ( (RTMessage           *)0 )
    , sendMethod    (               SendNormal )
    , signalName    ( (const char          *)0 )
    , actor         ( (const RTActor       *)0 )
    , info          ( (const RTActor_class *)0 )
    , compIndex     (                       -1 )
    , nrIncarns     (                        0 )
    , varName       ( (char                *)0 )
    , varValue      ( (char                *)0 )
    , histStrHist   ( (char                *)0 )
    , histStrCurr   ( (char                *)0 )
    , histHist      (                       -1 )
    , histCurr      (                       -1 )
    , targetMode    (                   Halted )
    , prev          ( (RTEventInfo         *)0 )
    , next          ( (RTEventInfo         *)0 )
{
}
