/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTLayerConnector.h>
#include <RTMemoryUtil.h>

//lint -save -esym(1927,NameBuffer::small_buffer)

RTLayerConnector::
NameBuffer::NameBuffer( const RTLayerConnector::NameBuffer & other )
    : value       ( (const char *)0 )
    , large_buffer( (char       *)0 )
{
#ifdef _lint
    small_buffer[ 0 ] = '\0';
#endif

    if( other.value != (const char *)0 )
    {
	int length = RTMemoryUtil::strlen( other.value );

	if( length < (int)sizeof( small_buffer ) )
	{
	    RTMemoryUtil::strcpy( small_buffer, other.value, length );
	    value = small_buffer;
	}
	else
	{
	    large_buffer = new char [ (unsigned)length + 1U ];
	    RTMemoryUtil::strcpy( large_buffer, other.value, length );
	    value = large_buffer;
	}
    }
}

//lint -restore
