/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTBindingEnd.h>
#include <RTLocalConnector.h>
#include <RTProtocol.h>

// This function is only called when have both a SPP and pending requests.

void RTLocalConnector::SppNode::connectAll( RTController * context )
{
    int          spp_size = spp->size();
    int          chances  = spp_size;
    RTBindingEnd spp_end;
    RTBindingEnd sap_end;

    spp_end.port  = spp;
    spp_end.index = spp_next;

    do
    {
	sap_end.port = pending->sap;

	for( ; pending->start < pending->limit; ++pending->start )
	{
	    while( spp_end.port->isBoundAt( spp_end.index ) != 0 )
	    {
		if( ++spp_end.index >= spp_size )
		    spp_end.index = 0;

		if( --chances <= 0 )
		{
		    spp_next = spp_end.index;
		    return;
		}
	    }

	    // we found a pair of unbound end ports

	    sap_end.index = pending->start;

	    bind( context, sap_end, spp_end );

	    if( ++spp_end.index >= spp_size )
		spp_end.index = 0;
	}
    }
    while( (pending = pending->next) != requests );

    spp_next = spp_end.index;
    pending  = (Request *)0;
}
