/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDecoding.h>
#include <RTEncoding.h>
#include <RTObject_class.h>

static void double_init( const RTObject_class *, void * target )
{
    *(double *)target = 0.0;
}

static void double_copy( const RTObject_class *,
			 void                 * target,
			 const void           * source )
{
    *(double *)target = *(const double *)source;
}

#if OBJECT_DECODE
static int double_decode( const RTObject_class *,
			  void                 * target,
			  RTDecoding           * coding )
{
    return coding->get_double( *(double *)target );
}
#endif

#if OBJECT_ENCODE
static int double_encode( const RTObject_class *,
			  const void           * source,
			  RTEncoding           * coding )
{
    return coding->put_double( *(const double *)source );
}
#endif

const RTObject_class RTType_double =
{
    (RTObject_class *)0,
    (RTSuperAccessFunction)0,
    "double",
    (RTVersionId)0,
    (RTFieldOffset)sizeof( double ),
    double_init,
    double_copy,
#if OBJECT_DECODE
    double_decode,
#endif
#if OBJECT_ENCODE
    double_encode,
#endif
    RTnop_destroy,
    0, (const RTFieldDescriptor *)0
};

#if OBJECT_DECODE
RTTypeInstaller double_installer( RTType_double );
#endif
