/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2010. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTLayerConnector.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

int RTProtocol::deregisterSAP( CallStyle style )
{
    RTController * controller = context();
    int            result     = 0;

#if OTRTSDEBUG >= DEBUG_VERBOSE
    controller->trace( RTController::LayerDeregisterSAP, this,
							 getRegisteredName() );
#endif

    if( ( _info->properties & RTPortDescriptor::MaskKind )
			   != RTPortDescriptor::KindUnwired ||
	( style == Programmatic &&
	  ( _info->properties & RTPortDescriptor::MaskRegisterLocked ) != 0 ) )
    {
	controller->setError( RTController::badOperation,
			      RTController::LayerDeregisterSAP,
			      this,
			      getRegisteredName() );
    }
    else if( ( getFlags() & RegisteredAsSAP ) == 0 )
    {
	controller->setError( RTController::dereg,
			      RTController::LayerDeregisterSAP,
			      this,
			      getRegisteredName() );
    }
    else
    {
	RTLayerConnector::lock();

	_layer->deregister( controller );
	_layer = (RTLayerData *)0;
	resetFlag( RegisteredAsSAP );

	RTLayerConnector::unlock();

	result = 1;
    }

    return result;
}
