/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTController.h>
#include <RTDiag.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

void RTProtocol::init( const RTPortDescriptor * info )
{
    RTAssert( _info == (RTPortDescriptor *)0 ); // this can only be called once

    _info = info;

    int replication = info->replication;

    if( replication != 0 )
    {
	if( ( info->properties & RTPortDescriptor::MaskKind )
			      != RTPortDescriptor::KindSpecial )
	{
	    _ends = new End [ (unsigned)replication ];

	    End * end = _ends;

	    for( int i = replication; --i >= 0; ++end )
	    {
		end->state       = End::Unbound;
		end->remote      = (RTProtocol *)0;
		end->remoteIndex = 0;
		end->signalMap   = (const int *)0;
	    }
	}

	context()->countPortIncarnate( replication );
    }
}
