/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTBindingEnd.h>
#include <RTPortDescriptor.h>
#include <RTProtocol.h>

int RTProtocol::peerAt( int index, RTBindingEnd & peer )
{
    if( index < 0 || _info->replication <= index )
	return 0; // index out of range

    if( _ends == (End *)0 )
	return 0; // no peers at all

    End * end = &_ends[ index ];

    if( end->state == End::Unbound )
	return 0; // not bound

    peer.port  = end->remote;
    peer.index = end->remoteIndex;

    return 1;
}
