/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTSoleController.h>
#include <RTSpecialPorts.h>
#include <RTSpecialSignals.h>
#include <RTTimerActor.h>

void RTSoleController::mainLoop( void )
{
    enter( RTJob::running );

    while( phase() != RTJob::finished )
    {
	int status = dispatch( Background );

	// In the absence of a thread dedicated to servicing the timing
	// service, we check here if any ticks have fired while we were
	// busy.

	RTActor * timerAgent;

	if( timer_interrupts != 0 )
	{
	    timer_interrupts = 0;
	    if( (timerAgent = RTTimerActor::soleInstance()) != (RTActor *)0 )
		timerAgent->rtsBehavior( RTInterruptSignal, RTControlPort );
	}
	else if( status == NoneToDeliver )
	    waitForEvents();
    }
}
