/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTActorClass.h>
#include <RTActor_class.h>
#include <RTComponentDescriptor.h>
#include <RTFieldDescriptor.h>
#include <RTPortDescriptor.h>
#include <RTSuperActor.h>

const RTStateId RTSuperActor::rtg_parent_state[] =
{
    0, 1, 1
};

static const RTActorClass RTSuperActor_ActorClass =
{
    (const RTActorClass *)0, "RTSuperActor", (RTVersionId)0,

    0, (const RTRelayDescriptor *)0,

    (RTActorCreator)0
};

static const char * const _names[] =
{
    "top",
    "starting",
    "running",

    // transitions
    "initialize",
    "go"

    // choice points
};

const RTComponentDescriptor RTSuperActor::rtg_capsule_roles[] =
{
    {
	"specials",
	(const RTActorClass *)0,
	RTOffsetOf( RTSuperActor, specials ),
	1, // id
	RTComponentDescriptor::Optional,
	1, // substitutable
	1, // replication
	0, (RTInterfaceDescriptor *)0,
	0, (RTBindingDescriptor *)0
    },
    {
	"application",
	(const RTActorClass *)0,
	RTOffsetOf( RTSuperActor, application ),
	2, // id
	RTComponentDescriptor::Optional,
	1, // substitutable
	1, // replication
	0, (RTInterfaceDescriptor *)0,
	0, (RTBindingDescriptor *)0
    }
};

const RTPortDescriptor RTSuperActor::rtg_ports[] =
{
    {
	"frame",
	(const char *)0,
	&Frame::Base::rt_class,
	RTOffsetOf( RTSuperActor, frame ),
	1, // replication
	rtid_frame, // id
	  RTPortDescriptor::KindSpecial
	+ RTPortDescriptor::NotificationDisabled
	+ RTPortDescriptor::RegisterNotPermitted
	+ RTPortDescriptor::VisibilityProtected
    },
    {
	"timer",
	(const char *)0,
	&Timing::Base::rt_class,
	RTOffsetOf( RTSuperActor, timer ),
	1, // replication
	rtid_timer, // id
	  RTPortDescriptor::KindSpecial
	+ RTPortDescriptor::NotificationDisabled
	+ RTPortDescriptor::RegisterNotPermitted
	+ RTPortDescriptor::VisibilityProtected
    }
};

#if USE_THREADS
const RTFieldDescriptor RTSuperActor::rtg_fields[] =
{
    {
	"timerController",
	RTOffsetOf( RTSuperActor, timerController ),
	(const RTObject_class *)0,
	(const RTTypeModifier *)0
    },
    {
	"timerThread",
	RTOffsetOf( RTSuperActor, timerThread ),
	(const RTObject_class *)0,
	(const RTTypeModifier *)0
    }
};
#endif

const RTActor_class RTSuperActor::rtg_class =
{
    (const RTActor_class *)0,

    _names,

    // states
    3, rtg_parent_state,

    &RTSuperActor_ActorClass,

    // components
    2, rtg_capsule_roles,

    // ports
    2, rtg_ports,

    // bindings
    0, (const RTLocalBindingDescriptor *)0,

    // ESVs
#if USE_THREADS
    sizeof( RTSuperActor::rtg_fields ) / sizeof( RTSuperActor::rtg_fields[0] ),
    RTSuperActor::rtg_fields
#else
    0, (const RTFieldDescriptor *)0
#endif
};

const RTActor_class * RTSuperActor::getActorData( void ) const
{
    return &RTSuperActor::rtg_class;
}
