/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemon.h>
#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTToolsetObserver.h>

void RTToolsetObserver::handleChain( void )
{
    TO_chainInfo * myChainInfo = (TO_chainInfo *)structInfo.ptr;
    RTDaemonInfo * daemonInfo  = new RTDaemonInfo;

    daemonInfo->setInfoChain( myChainInfo->actor,
			      myChainInfo->state,
			      myChainInfo->chain,
			      myChainInfo->position );

    if( structInfo.func == CMD_ADD_CHAIN )
    {
	int probeNr = addInfo( daemonInfo );
	if( probeNr >= 0 )
	{
	    sendResultCode( RES_OK );
	    debugger->getPresence( probeNr,
				   observerId,
				   structInfo.daemon.number );
	}
	else
	{
	    sendResultCode( RES_BAD_CHAIN );
	    delete daemonInfo;
	}
    }
    else // structInfo.func == CMD_DEL_CHAIN
    {
	if( delInfo( daemonInfo ) <= 0 ) // number of actors deleted
	    sendResultCode( RES_BAD_CHAIN );
	else
	    sendResultCode( RES_OK );

	delete daemonInfo;
    }
}
