/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDaemonInfo.h>
#include <RTDebugger.h>
#include <RTToolsetObserver.h>

void RTToolsetObserver::handleVariable( void )
{
    TO_variableInfo * myVarInfo  = (TO_variableInfo *)structInfo.ptr;
    RTDaemonInfo    * daemonInfo = new RTDaemonInfo;

    daemonInfo->setInfoVariable( myVarInfo->actor, myVarInfo->variable );

    if( structInfo.func == CMD_ADD_VAR )
    {
	int probeNr = addInfo( daemonInfo );
	if( probeNr >= 0 )
	{
	    sendResultCode( RES_OK );
	    debugger->getPresence( probeNr,
				   observerId,
				   structInfo.daemon.number );
	}
	else
	{
	    sendResultCode( RES_BAD_VAR );
	    delete daemonInfo;
	}
    }
    else // structInfo.func == CMD_DEL_VAR
    {
	if( delInfo( daemonInfo ) <= 0 ) // number of actors deleted
	    sendResultCode( RES_BAD_VAR );
	else
	    sendResultCode( RES_OK );

	delete daemonInfo;
    }
}
