/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTActorSlot_inl__
#define __RTActorSlot_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActorSlot_h__
#include <RTActorSlot.h>
#endif

RTS_INLINE int RTSmallOptional::supports( int size )
{
    return size < threshold;
}

RTS_INLINE void RTSmallOptional::insert( int p, int n )
{
    _actor = (RTActor *)
	     ( ( p << prev_shift ) + ( n << next_shift ) + 1 ); //lint !e701
}

RTS_INLINE void RTSmallOptional::prev( int p )
{
    int links = (int)(long)_actor;

    links &= ~ ( link_mask << prev_shift );
    links |=             p << prev_shift; //lint !e701

    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::prev( void ) const
{
    return ( (int)(long)_actor >> prev_shift ) & link_mask; //lint !e702
}

RTS_INLINE void RTSmallOptional::next( int n )
{
    int links = (int)(long)_actor;

    links &= ~ ( link_mask << next_shift );
    links |=             n << next_shift; //lint !e701

    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::next( void ) const
{
    return ( (int)(long)_actor >> next_shift ) & link_mask; //lint !e702
}

RTS_INLINE int RTSmallOptional::inuse( void ) const
{
    return ( 1 & (int)(long)_actor ) == 0;
}

#endif // __RTActorSlot_inl__
