/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTQueue_h__
#define __RTQueue_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTConfig_h__
#include <RTConfig.h>
#endif

class RTQueue
{
public:
    struct Block
    {
	enum { Size = 30 };

	Block * next;
	int     used;
	void  * data[ Size ];
    };

    class Iterator
    {
    public:
	RTS_INLINE explicit Iterator( const RTQueue & );
	RTS_INLINE          ~Iterator( void );

	void              * next( void );

    private:
	Block * block;
	int     index;

	// useful only to silence lint
	RTS_INLINE          Iterator( void );
    };

    RTS_INLINE          RTQueue( void );
			RTQueue( const RTQueue & );
			~RTQueue( void );

    RTQueue           & operator=( const RTQueue & );

    void                add( void * );
    void                remove( void * );
    RTS_INLINE int      isEmpty( void ) const;
    int                 length( void ) const;

private:
    friend class Iterator;

    Block * head;
    Block * tail;
};

#if RTS_INLINES
#include <RTQueue.inl>
#endif

#endif // __RTQueue_h__
