/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

// This depends on the implementation of Nucleus NET more than
// I would like, but there seems to be no other way to obtain
// this information.

extern "C" int RTinet_getname( int              sock,
			       RTinet_address * address,
			       RTinet_port    * port )
{
    if( sock < 0 || sock >= NSOCKETS )
	return 0;

    sock_struct * socket = socket_list[ sock ];

    if( socket == (sock_struct *)0 )
	return 0;

    RTMemoryUtil::memcpy( address,
			  &socket->local_addr.ip_num,
			  (int)sizeof( *address ) );

    *port = socket->local_addr.port_num;

    return 1;
}
