/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTMemoryUtil.h>
#include <RTinet.h>
#include <RTtcp.h>

extern "C" int RTinet_sendto( int                    sock,
			      const char           * data,
			      int                    size,
			      const RTinet_address * address,
			      RTinet_port            port )
{
    addr_struct addr;

    RTMemoryUtil::memset( &addr, 0, (int)sizeof( addr ) );
    addr.family = NU_FAMILY_IP;
    addr.port   = port;
    RTMemoryUtil::memcpy( &addr.id, address, (int)sizeof( *address ) );

    int count;

    if( (count = NU_Send_To( sock, (char *)data, size, 0,
			     &addr, (int)sizeof( addr ) )) < 0 )
    {
	count = -1;
    }

    return count;
}
