/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebuggerInput.h>
#include <RTDiag.h>
#include <RTDiagStream.h>
#include <RTOse.h>

#include <bios.h>

int RTDebuggerInput::nextChar( void )
{
    // The following depends on the presence of the dbgread bios call;
    // replace following code as necessary for other implementations.

    static long handle = 0L;
    int         length = -1;
    char        buffer[ 2 ];

    buffer[ 0 ] = '\0';
    buffer[ 1 ] = '\0';

    if( handle == 0L )
	handle = biosOpen( "dbgread" );

    if( handle != 0L )
	length = biosCall( handle, 0, &buffer[ 0 ], 1 );

    if( length <= 0 )
	buffer[ 0 ] = '\0';
    else
    {
	if( buffer[ 0 ] == '\r' )
	    buffer[ 0 ] = '\n'; // convert carriage return to newline

#if ! defined( softOSE )
	RTDiag::out() << buffer;
#endif
    }

    return (int)buffer[ 0 ];
}
