/*
 *  Licensed Materials - Property of IBM
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS
 *  Copyright IBM Corporation 1999, 2008. All Rights Reserved.
 *  U.S. Government Users Restricted Rights -  Use, duplication or
 *  disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTSyncObject_h__
#define __RTSyncObject_h__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTMutex_h__
#include <RTMutex.h>
#endif

struct RTTimespec;

class RTSyncObject : private RTMutex
{
protected:
    int             signalled;
    pthread_cond_t  cv;

public:
	    RTSyncObject( void );
	    ~RTSyncObject( void );

    void    signal( void );
    void    wait( void );
    void    timedwait( const RTTimespec & );

private:
    // unavailable methods
    RTSyncObject( const RTSyncObject & );
    RTSyncObject & operator=( const RTSyncObject & );
};

#endif // __RTSyncObject_h__
