/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2009. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTActorSlot_inl__
#define __RTActorSlot_inl__ included

#ifdef PRAGMA
#pragma interface
#endif

#ifndef __RTActorSlot_h__
#include <RTActorSlot.h>
#endif

RTS_INLINE int RTSmallOptional::supports( int size )
{
    return (size_t)size < (size_t)threshold;
}

RTS_INLINE void RTSmallOptional::insert( int p, int n )
{
    _actor = (RTActor *)
	      ( ((size_t)p << prev_shift ) + ( (size_t)n << next_shift ) + 1 ); //lint !e701
}

RTS_INLINE void RTSmallOptional::prev( int p )
{
    size_t links = (size_t)_actor;
	
	links = links & ~(size_t)(( (size_t)link_mask) << (short)prev_shift );
//	links = links & ~(((size_t)link_mask) << (short)prev_shift );
	links = links | ((size_t)p<< prev_shift); //lint !e701
    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::prev( void ) const
{
    return (int)((size_t)_actor >> prev_shift & link_mask); //lint !e702
}

RTS_INLINE void RTSmallOptional::next( int n )
{
    size_t links = (size_t)_actor;

    links = links & (size_t) (~ ( link_mask << next_shift ));
    links = links | ((size_t)n << next_shift); //lint !e701

    _actor = (RTActor *)links;
}

RTS_INLINE int RTSmallOptional::next( void ) const
{
    return ( (int)(size_t)_actor >> next_shift ) & link_mask; //lint !e702
}

RTS_INLINE int RTSmallOptional::inuse( void ) const
{
    return ( (size_t)1 & (size_t)_actor ) == (size_t)0;
}

#endif // __RTActorSlot_inl__
