/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2009. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTAsciiDecoding.h>
#include <sys/types.h>

int RTAsciiDecoding::get_address( void * & address )
{
    size_t	  value  = 0UL;
    int           status = 0;
    char          byte;
    int           digits = 0;

    if( getNonWhite( byte ) == 0 )
	return 0;

    if( byte != '0' )
    {
	ungetByte( byte );
	return 0;
    }

    if( getByte( byte ) == 0 )
	return 0;

    if( byte != 'x' )
    {
	ungetByte( byte );
	ungetByte( '0' );
	return 0;
    }

    while( getByte( byte ) != 0 )
    {
	if( '0' <= byte && byte <= '9' )
	    byte -= '0';
	else if( 'a' <= byte && byte <= 'f' )
	    byte -= 'a' - 10;
	else if( 'A' <= byte && byte <= 'F' )
	    byte -= 'A' - 10;
	else
	{
	    ungetByte( byte );
	    if( status == 0 )
	    {
		ungetByte( 'x' );
		ungetByte( '0' );
	    }
	    break;
	}

	if( value != 0UL || byte != '\0' )
	    digits += 1;

	value <<= 4;
	value += (unsigned long)(int)byte;
	status = 1;
    }

    if( digits > 2 * (int)sizeof( address ) )
	status = 0;

    else if( status != 0 )
	address = (void *)value;

    return status;
}
