/*
 *  Licensed Materials - Property of IBM
 *  Component IBM Rational ROSE_RT BUILD : TARGET_RTS
 *  Copyright IBM Corporation 1999, 2009. All Rights Reserved.
 *  U.S. Government Users Restricted Rights -  Use, duplication or
 *  disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#ifndef __RTtcp_h__
#define __RTtcp_h__ included

#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/filio.h>
#include <sys/sockio.h>
#include <netinet/in.h>
#include <netdb.h>
#include <net/if.h>

typedef struct sockaddr  SocketAddress;
typedef socklen_t        SocketAddressSize;

#define INET_HaveLength  0

#define INET_accept      accept
#define INET_bind        bind
#define INET_close       close
#define INET_connect     connect
#define INET_error( sd ) errno
#define INET_getsockname getsockname
#define INET_ioctl       ioctl
#define INET_listen      listen
#define INET_lookup      gethostbyname
#define INET_recv        recv
#define INET_recvfrom    recvfrom
#define INET_send        send
#define INET_sendto      sendto
#define INET_setsockopt  setsockopt
#define INET_socket      socket

#define INET_EALREADY    EALREADY
#define INET_EINPROGRESS EINPROGRESS
#define INET_EINTR       EINTR
#define INET_EISCONN     EISCONN
#define INET_EWOULDBLOCK EWOULDBLOCK

#endif // __RTtcp_h__
