/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDiag.h>
#include <RTSyncObject.h>

#include <errno.h>

void RTSyncObject::wait( void )
{
    if( mutex_lock( &mutex ) != 0 )
	RTDiag::panic( "mutex_lock" );

    if( signalled == 0 )
    {
	int rc = cond_wait( &cv, &mutex );

	if( rc == 0 )
	{
	    // signalled
	}
	else if( rc == EINTR )
	{
	    // interrupted
	}
	else if( rc == EAGAIN )
	{
	    // ??
	}
	else if( errno != EINTR &&
		 errno != EAGAIN )  // ??
	{
	    RTDiag::panic( "cond_wait" );
	}
    }

    signalled = 0;

    if( mutex_unlock( &mutex ) != 0 )
	RTDiag::panic( "mutex_unlock" );
}
