/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTDebuggerInput.h>

#if defined( VXWORKS60 )
	#include <stdio.h>
#else
	#include <RTstdio.h>
#endif
#include <errno.h>

int RTDebuggerInput::nextChar( void )
{
    FILE * f = stdin;
    int    c;

    for(;;)
    {
	c = fgetc( f );

	if( feof( f ) != 0 )
	{
	    // skip other tests
	}
	else if( ferror( f ) == 0 )
	{
	    break;
	}
#if defined( EINTR )
	else if( errno == EINTR )
	{
	    clearerr( f );
	    continue;
	}
#endif
	else
	{
	    perror( "fgetc" );
	}

	c = EOF;
	break;
    }

    return c;
}

