/*
 * Licensed Materials - Property of IBM                               
 * Component IBM Rational ROSE_RT BUILD : TARGET_RTS                  
 * Copyright IBM Corporation 1999, 2008. All Rights Reserved.       
 * U.S. Government Users Restricted Rights -  Use, duplication or     
 * disclosure restricted by GSA ADP  Schedule Contract with IBM Corp.
 */

#include <RTWinCE.h>

void RTConsole::enqueueChar( TCHAR tch )
{
    enum Action
    {
	Add, Beep, Done
    };

    if( (unsigned)tch >= 0x80U )
    {
	MessageBeep( MB_OK );
	return; // a non-ASCII character
    }

    Action action = Add;
    char   ch     = (char)tch;
    char   echo[ 4 ];

    if     ( ch == '\r' ) ch = '\n';
    else if( ch == '\t' ) ch = ' ';

    echo[ 0 ] = ch;
    echo[ 1 ] = '\0';

    input_mutex.enter();

    int room = input.head - input.tail;

    if( room <= 0 )
	room += input.Size;

    if( ch == '\b' )
    {
	int previous = input.tail - 1;

	if( previous < 0 )
	    previous = input.Size - 1;

	if( input.head == input.tail )
	    action = Beep; // no characters to delete
	else if( input.data[ previous ] == '\n' )
	    action = Beep; // at beginning of line
	else
	{
	    input.tail = previous;
	    echo[ 1 ] = ' ';
	    echo[ 2 ] = '\b';
	    echo[ 3 ] = '\0';
	    action = Done;
	}
    }
    else if( room == 0 )
	action = Beep;
    else
    {
	input.data[ input.tail++ ] = ch;

	if( input.tail >= input.Size )
	    input.tail  = 0;

	if( ch == '\n' )
	    ++input.lines;
    }

    input_mutex.leave();

    if( action == Beep )
	MessageBeep( MB_OK );
    else
    {
	outputString( echo );
	if( ch == '\n' )
	    input_available.signal();
    }
}
